#include "testlib.h"
#include <vector>

using namespace std;

const int MAX_N = 50000;

const long long numGr = 6;
const long long maxN[numGr] = {10, 100, 1000, MAX_N, MAX_N, MAX_N};
const long long maxM[numGr] = {20, 20, 20, 2, 'j' - 'a' + 1, 20};

struct DSU
{
	vector < int > p;
	DSU(int n) : p(n, -1) {}

	int getRoot(int a) { return p[a] == -1 ? a : p[a] = getRoot(p[a]); }
	bool merge(int a, int b)
	{
		a = getRoot(a);
		b = getRoot(b);
		if (a == b)
			return false;
		p[a] = b;
		return true;
	}
};

int main(int argc, char * argv[])
{
    registerValidation(argc, argv);
	int group = atoi(validator.group().c_str());
	//group = 5;
    int n = inf.readInt(2, maxN[group], "n");
    inf.readEoln();

	DSU dsu(n);
    for (int i = 0; i < n - 1; ++i)
    {
        int a = inf.readInt(1, n, "a_i");
        inf.readSpace();
        int b = inf.readInt(1, n, "b_i");
        inf.readEoln();
        ensuref(dsu.merge(a - 1, b - 1), "Graph must be a tree");
    }

	string g = inf.readLine();
	ensuref(g.size() == n, "Size of string is not n");
	int f = 0;
	for (int j = 0; j < n; j++){
		ensuref(g[j] >= 'a' && g[j] <= 'z', "There is illegal character");
    	ensuref(g[j] <= 't', "There is illegal character");
	    f = max(f, g[j] - 'a');
	}
	ensuref(f <= maxM[group], "There is illegal character");
    inf.readEof();

    return 0;
}