/**
 *    author:  [itmo] enot.1.10
 *    created: 18.02.2017 06:42:37       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 5e4 + 10;
const int C = 20;

struct T
{
    int a[C][C];
    
    T()
    {
        memset(a, 0, sizeof a);
    }

    inline int* operator [] (int i)
    {
        return a[i];
    }

    void clear()
    {
        memset(a, 0, sizeof a);
    }
};

inline void operator += (T &a, T &b)
{
    forn(i, C) forn(j, C) a[i][j] = max(a[i][j], b[i][j]);
}

T tmp;

inline void operator *= (T &a, int x)
{
    forn(i, C) forn(j, C) tmp[i][j] = 0;
    forn(i, C) if (i != x) forn(j, C) if (j != x) tmp[j][x] = max(tmp[j][x], a[i][j] + 1);
    a += tmp;
}


vi v[N];
T t[N];
char s[N];

void dfs0(int x, int xx)
{
    for (int y : v[x]) if (y != xx)
    {
        dfs0(y, x);
        t[x] += t[y];
    }
    t[x] *= s[x] - 'a';
}

int res = 1;

void upd(T &a)
{   
    forn(i, C) forn(j, C) res = max(res, a[i][j]);
}

void dfs1(int x, int xx, T &up)
{
    vi sons;
    for (int y : v[x]) if (y != xx) sons.pb(y);
    if (!sz(sons))
    {
        up *= s[x] - 'a';
        upd(up);
        return;
    }

    if (sz(sons) == 1)
    {
        up *= s[x] - 'a';
        dfs1(sons[0], x, up);
        return;
    }

    int n = sz(sons);

    vector<T> pref(n + 1);
    vector<T> suf(n + 1);

    pref[0] = up;
    forn(i, n)
    {
        pref[i + 1] = pref[i];
        pref[i + 1] += t[sons[i]];
    }

    suf[n] = up;
    for (int i = n - 1; i >= 0; --i)
    {
        suf[i] = suf[i + 1];
        suf[i] += t[sons[i]];
    }

    T z;
    forn(i, n)
    {
        z = pref[i];
        z += suf[i + 1];
        z *= s[x] - 'a';
        dfs1(sons[i], x, z);
    }
}


int main()
{
    assert(freopen("canderlabrum.in", "r", stdin));
    assert(freopen("canderlabrum.out", "w", stdout));
    int n;
    scanf("%d", &n);
    forn(i, n - 1)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x, --y;
        v[x].pb(y);
        v[y].pb(x);
    }
    scanf("%s", s);
    dfs0(0, -1);
    T z;
    dfs1(0, -1, z);

    printf("%d\n", res);


    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
