#include "testlib.h"
#include <set>

using namespace std;

const int MAX_N = 100000;
const int MAX_M = 100000;
const int MAX_Q = 100000;


int main(int argc, char * argv[])
{
    registerValidation(argc, argv);
    int n = inf.readInt(1, MAX_N, "n");
    inf.readSpace();
    int m = inf.readInt(0, min<long long>(MAX_M, n*(n-1LL)/2), "m");
    inf.readEoln();
    
    set < pair < int , int > > e;
    for (int i = 0; i < m; ++i)
    {
        int a = inf.readInt(1, n, "a_i");
        inf.readSpace();
        int b = inf.readInt(1, n, "b_i");
        inf.readEoln();
        ensuref(a != b, "Ends of an edge must be distinct");
        ensuref(e.count({a, b}) == 0, "Graph must not contain multi-edges");
        e.insert({a, b});
        e.insert({b, a});
    }
    
    int q = inf.readInt(1, MAX_Q, "q");
    inf.readEoln();
    for (int i = 0; i < q; ++i)
    {
        int l = inf.readInt(1, n, "l_i");
        inf.readSpace();
        inf.readInt(l, n, "r_i");
        inf.readEoln();
    }    
    inf.readEof();

    return 0;
}
