import random
import math
random.seed('personal03/balls')

class TestGen:
    def __init__(self):
        self.test_number = 0


    def generate_samples(self):
        print('Generating samples...')
        self.print_test([3, 1, -2, 4, 7])
    

    def generate_first_group_of_tests(self):
        print('Generating subtask1...')
        self.print_test([25])
        self.print_test([-37])
        self.print_test([2, 3])
        self.print_test([-5, -6])
        self.print_test([1, 3])
        self.print_test([-7, -5])
        self.print_test([8, 6])
        self.print_test([1, 3, 7])
        self.print_test([1, 8, 5])
        self.print_test([13, 12, 11, 14])
        for tc in range(5):
            n = random.randint(5, 1000)
            for mc in [10**3, 10**4]:
                balls = []
                cs = set()
                for i in range(n):
                    x = random.randint(-mc, mc)
                    while x in cs:
                        x = random.randint(-mc, mc)
                    balls.append(x)
                    cs.add(x)
                self.print_test(balls)

    
    def random_c(self, mc):
        if random.randint(1, 2) == 1:
            x = random.randint(-mc, -mc // 10**4)
        else:
            x = random.randint(mc // 10**4, mc)
        return x


    def generate_equal_distribution_test(self, n, mc):
        x = random.randint(-10**9, 10**4)
        diff = random.randint(1, (10**9 - x) // n)
        balls = []
        for i in range(n):
            balls.append(x)
            x += diff
        random.shuffle(balls)
        self.print_test(balls)


    def generate_equal_distribution_with_small_trash_test(self, n, mc):
        x = random.randint(-10**9, 10**3)
        diff = random.randint(2, (mc - x) // (n - 1))
        balls = []
        for i in range(n - 1):
            balls.append(x)
            x += diff
        index = random.randint(0, len(balls) - 1)
        balls.append(balls[index] + random.randint(1, diff - 1))
        random.shuffle(balls)
        self.print_test(balls)


    def generate_equal_distribution_with_trash_test(self, n, mc):
        x = random.randint(-10**9, 10**3)
        diff = random.randint(2, (10**9 - x) // (n - n // 5))
        balls = []
        used = set()
        for i in range(n - n // 5):
            balls.append(x)
            used.add(x)
            x += diff
        for i in range(n // 5):
            index = random.randint(0, len(balls) - 1)
            x = balls[index] + random.randint(1, diff - 1)
            while x in used:
                index = random.randint(0, len(balls) - 1)
                x = balls[index] + random.randint(1, diff - 1)
            balls.append(x)
            used.add(x)
        random.shuffle(balls)
        self.print_test(balls)


    def generate_second_group_of_tests(self):
        print('Generating subtask2...')
        self.print_test([23])
        self.print_test([-24])
        self.print_test([0, 1])
        self.print_test([-10, -11])
        self.print_test([5, 12, 9])
        self.print_test([113, 112, 111, 114])
        self.print_test([10**9, 10**9 - 1])
        self.print_test([-10**9, -10**9 + 1])
        self.print_test([10**9, 10**9 - 2])
        for i in range(3):
            self.generate_equal_distribution_test(10**3, 10**9)
            self.generate_equal_distribution_with_small_trash_test(10**3, 10**9)
            self.generate_equal_distribution_with_trash_test(10**3, 10**9)
        for tc in range(5):
            for mc in [10**3, 10**4, 10**9]:
                n = random.randint(5, 1000)
                balls = []
                cs = set()
                for i in range(n):
                    x = self.random_c(mc)
                    while x in cs:
                        x = self.random_c(mc)
                    balls.append(x)
                    cs.add(x)
                self.print_test(balls)


    def generate_third_group_of_tests(self):
        print('Generating subtask3...')
        self.print_test([-100, -99])
        self.print_test([-13, -14])
        self.print_test([15, 22, 19])
        self.print_test([-113, -112, -111, -114])
        self.print_test([10**9, 10**9 - 1])
        self.print_test([-10**9, -10**9 + 1])
        self.print_test([10**9, 10**9 - 2])
        for i in range(3):
            self.generate_equal_distribution_test(10**5, 10**9)
            self.generate_equal_distribution_with_small_trash_test(10**5, 10**9)
            self.generate_equal_distribution_with_trash_test(10**5, 10**9)
        for tc in range(5):
            for mc in [10**5, 10**6, 10**9]:
                n = random.randint(1, 10**5)
                balls = []
                cs = set()
                for i in range(n):
                    x = self.random_c(mc)
                    while x in cs:
                        x = self.random_c(mc)
                    balls.append(x)
                    cs.add(x)
                self.print_test(balls)

    def generate_max_tests(self):
        pass


    def print_test(self, coordinates):
        self.test_number += 1
        print('Generating test %d' % self.test_number)
        
        test_name = '{0:0=2d}'.format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(coordinates), file=test_file)
        print(' '.join(map(str, coordinates)), file=test_file)
        test_file.close()


    def generate_all_tests(self):
        #Samples
        self.generate_samples() 
        
        #First group of tests
        self.generate_first_group_of_tests()
        
        #Second group of tests
        self.generate_second_group_of_tests()

        #Third group of tests
        self.generate_third_group_of_tests()

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
